Bug 491490 - Review Request: ghmm - A library with data structures and algorithms for Hidden Markov Models
Review Request: ghmm - A library with data structures and algorithms for Hidd...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-21 17:13 EDT by Conrad Meyer
Modified: 2009-11-30 23:46 EST (History)
4 users (show)

See Also:
Fixed In Version: 0.7-4.svn2286.fc11
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-10-23 10:06:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Conrad Meyer 2009-03-21 17:13:41 EDT
Spec URL: http://konradm.fedorapeople.org/fedora/SPECS/ghmm.spec
SRPM URL: http://konradm.fedorapeople.org/fedora/SRPMS/ghmm-0.7-1.svn2251.fc10.src.rpm
Description:
The General Hidden Markov Model library (GHMM) is a freely available
LGPL-ed C library implementing efficient data structures and algorithms
for basic and extended HMMs.

It is developed by the Algorithmics group at the Max Planck Institute
for Molecular Genetics.

Features:
  * Discrete and continuous emissions
  * Mixtures of PDFs for continuous emissions
  * Non-homogenous Markov chains
  * Pair HMMs (contributed by Genoscope)
  * Clustering and mixture modelling for HMMs
  * Graphical Editor HMMEd
  * Python bindings
  * XML-based file format



Note: This is a SAGE package (https://fedoraproject.org/wiki/SIGs/SciTech/SAGE).

Rpmlint output:
ghmm.spec:72: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.src:72: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \

These are used so that when python libs are built/installed during the make process, they use the correct flags. RPM_BUILD_ROOT is not defined here, it's just reference when the makefile is run in %build/%install.

ghmm.x86_64: W: shared-lib-calls-exit /usr/lib64/libghmm.so.1.0.0 exit@GLIBC_2.2.5

Poor programming practice, not a packaging problem.

ghmm-devel.x86_64: W: no-documentation
ghmm-static.x86_64: W: no-documentation

Ignorable.

This builds in koji:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1252576
Comment 1 D Haley 2009-05-31 10:41:56 EDT
Its me again. Here are my comments for this package.

General comments:

* For ease of update, I recommend defining a svnrev macro, then using that where appropriate.
* DTD is named in an unusual manner, with version number after .dtd --should this be renamed?
*-config script needs correcting to produce appropriate output when called with multiple flags. This is the same problem as for bug 475065 (why is this identical to the other one?)

*"# Commented out because it seems broken" - is the check failing, or just not running?

Review comments:

#  MUST: rpmlint must be run on every package. The output should be posted in the review.
$ rpmlint -v ghmm.spec ../SRPMS/ghmm-0.7-1.svn2251.fc10.src.rpm ../RPMS/i386/ghmm-0.7-1.svn2251.fc10.i386.rpm ../RPMS/i386/ghmm-static-0.7-1.svn2251.fc10.i386.rpm ../RPMS/i386/ghmm-devel-0.7-1.svn2251.fc10.i386.rpm ../RPMS/i386/ghmm-debuginfo-0.7-1.svn2251.fc10.i386.rpm 
ghmm.spec:71: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.src: I: checking
ghmm.src:71: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.i386: I: checking
ghmm.i386: W: shared-lib-calls-exit /usr/lib/libghmm.so.1.0.0 exit@GLIBC_2.0
ghmm-static.i386: I: checking
ghmm-static.i386: W: no-documentation
ghmm-devel.i386: I: checking
ghmm-devel.i386: W: no-documentation
ghmm-debuginfo.i386: I: checking
5 packages and 1 specfiles checked; 0 errors, 5 warnings.

Please notify upstream about the exit() call, and ask for a fix; notification of upstream is required, upstream response is not, although reply should be given here if upstream responds.

# MUST: The package must be named according to the Package Naming Guidelines .
OK

# MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
OK
# MUST: The package must meet the Packaging Guidelines .
OK
# MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
FAIL : Running my quick and dirty grep (x`grep "any later"` != x"") over the files indicates that the following files don't have an LGPLv2+ boilerplate:
Bad: ./ghmmwrapper/ghmmwrapper_wrap.c
Bad: ./tests/two_states_three_symbols.c
Bad: ./tests/read_fa.c
Bad: ./tests/read_smodel.c
Bad: ./tests/label_higher_order_test.c
Bad: ./tests/randvar_test.c
Bad: ./tests/generate_PHI.c
Bad: ./tests/shmm_viterbi_test.c
Bad: ./tests/chmm_test.c
Bad: ./tests/libxml-test.c
Bad: ./tests/ghmmunittests.c
Bad: ./tests/sequences_old_format.c
Bad: ./tests/chmm.c
Bad: ./tests/root_finder_test.c
Bad: ./tests/test_gsl_ran_gaussian_tail.c
Bad: ./tests/sequences_test.c
Bad: ./tests/coin_toss_test.c
Bad: ./tools/smo2xml.c
Bad: ./tools/probdist.c
Bad: ./tools/scluster.c
Bad: ./tools/smix_hmm.c
Bad: ./tools/cluster.c
Bad: ./ghmm/mt19937ar.c
Bad: ./ghmm/psequence.h
Bad: ./ghmm/obsolete.h
Bad: ./win_config.h
Bad: ./config.h

./ghmm/mt19937ar.c appears to have BSD style licence, and others no licence at all. 

* Also the copyright file says parts are from the Sun BSD style licence, but no clear relation as to which source files this applies to is given.

* The COPYING links to the GPL, which is included but their website says LGPL. This needs to be clarified by upstream.

* Requiring the GNU Scientific Library will make the package GPLv3(+?), not LGPL.

* Finally the COPYING file must be bundled into %doc as this is the user "recieving" a copy of the LGPL/GPL (additional to COPYRIGHT.txt).

This will all need to be fixed. At the very least you need to change the licence field, as the licences are mixed. You should notify upstream about this so they can relicence, and/or fix the missing licences.

# MUST: The License field in the package spec file must match the actual license.
FAIL: see above
# MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
FAIL: see above
# MUST: The spec file must be written in American English.
OK
# MUST: The spec file for the package MUST be legible.
OK
# MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this pacKoji OKkage, please see the Source URL Guidelines for how to deal with this.
FAIL: 
$ svn export -r2251 https://ghmm.svn.sourceforge.net/svnroot/ghmm/trunk/ghmm ghmm
$ tar -cjf ghmm.tar.bz2 ghmm/
$ md5sum ghmm.tar.bz2 
5a410a91489785811535622a89bd25ab  ghmm.tar.bz2
$ md5sum ../ghmm.tar.bz2 
00c08b65e71b51e63b2922ea9ce4883b  ../ghmm.tar.bz2
Could not reproduce MD5 included in SRPM. Please check and advise of correct MD5.

Also, please provide exact SVN (including rev number) command for a current checkout, so md5 can match if someone executes the suggested command.

# MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
Koji OK.
# MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
N/A
# MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
OK
# MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
N/A
# MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
OK
# MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. 
N/A
# MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 
OK
# MUST: A Fedora package must not list a file more than once in the spec file's %files listings. 
FAIL: please fix
# MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. 
OK
# MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). 
OK
# MUST: Each package must consistently use macros. 
OK, but I strongly recommend defining an svn version number macro
# MUST: The package must contain code, or permissable content.
OK, pending licence clarification.
# MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 
OK
# MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
OK
# MUST: Header files must be in a -devel package. 
OK
# MUST: Static libraries must be in a -static package. 
OK
# MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). 
N/A
# MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. 
OK
# MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
OK
# MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
OK
# MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 
N/A
# MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
OK
# MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). 
OK
# MUST: All filenames in rpm packages must be valid UTF-8. 
OK

*  SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. 
FAIL: See earlier licence problems
* SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. 
N/A
* SHOULD: The reviewer should test that the package builds in mock. 
Koji OK
* SHOULD: The package should compile and build into binary rpms on all supported architectures. 
FAIL: Please run scratch tasks for each fedora version (i.e. also do F-9 F-10)
* SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
FAIL: Not checked by reviewer (me), will check on next SRPM.
* SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. 
OK
* SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. 
OK
* SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. 
N/A
* SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the ile itself. 
N/A
Comment 2 D Haley 2009-05-31 10:45:10 EDT
Also, can you set the depends upon and blocks fields for this bug?
Comment 3 Jason Tibbitts 2009-07-01 19:45:21 EDT
It's been a month since that nice review work by D Haley without response.  Did you wish to continue with this package?  I'll go ahead and close it out soon if there's no further progress.
Comment 4 Conrad Meyer 2009-07-05 16:12:04 EDT
Ah, sorry, I didn't notice that I wasn't receiving email from this account for the past month or so. I plan to follow up on the review, I'm just catching up to all the mail I've missed. Sorry.
Comment 5 Jason Tibbitts 2009-08-20 18:14:11 EDT
Any chance of being caught up soon?  Should this ticket stay open?
Comment 6 Conrad Meyer 2009-08-20 19:48:20 EDT
I haven't had time, sorry. This should probably be closed.
Comment 7 D Haley 2009-08-22 22:31:34 EDT
I have notified upstream of the licencing and rpmlint issues, and am happy to complete this package (provided someone else reviews of course :) ).

I have also found that their unit tests fail on my machine, and have notified upstream:

#Upstream has been notified of exit() calls.
#https://sourceforge.net/tracker/?func=detail&aid=2842844&group_id=67094&atid=516866
#Upstream has been notified of licencing issues
#https://sourceforge.net/tracker/?func=detail&aid=2842854&group_id=67094&atid=516866
#Upstream has been notfied of unit test problems
#https://sourceforge.net/tracker/?func=detail&aid=2842847&group_id=67094&atid=516867
Comment 8 D Haley 2009-10-09 23:53:10 EDT
SPEC URL: http://dhd.selfip.com/427e/ghmm.spec
SRPM URL: http://dhd.selfip.com/427e/ghmm-0.7-2.svn2286.fc10.src.rpm

Koji Builds:
F10:http://koji.fedoraproject.org/koji/taskinfo?taskID=1739149
F11:http://koji.fedoraproject.org/koji/taskinfo?taskID=1739154
F12:http://koji.fedoraproject.org/koji/taskinfo?taskID=1739159

Rpmlint output:
 rpmlint `cat tmp | awk '{print $2}'`
ghmm.src:94: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.i386: W: shared-lib-calls-exit /usr/lib/libghmm.so.1.0.0 exit@GLIBC_2.0
ghmm-static.i386: W: no-documentation
ghmm-devel.i386: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 4 warnings.

$ cat tmp
Wrote: /home/makerpm/rpmbuild/SRPMS/ghmm-0.7-2.svn2286.fc10.src.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-0.7-2.svn2286.fc10.i386.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-static-0.7-2.svn2286.fc10.i386.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-devel-0.7-2.svn2286.fc10.i386.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-debuginfo-0.7-2.svn2286.fc10.i386.rpm


Just a note : I had some problems with the MD5 checking owing to SVN modifying then files date fields to match my local timezone. the instructions in the SPEC file seemed to work. You can do a full diff to see the changes if need be.
Comment 9 Thomas Spura 2009-10-18 20:34:17 EDT
Hmm, rpmbuild -ba faild:

Installed, but unpacked:
   /usr/lib/python2.6/site-packages/HMMEd-0.8-py2.6.egg-info
   /usr/lib/python2.6/site-packages/HMMEditingContext.py
   /usr/lib/python2.6/site-packages/HMMEditingContext.pyc
   /usr/lib/python2.6/site-packages/HMMEditingContext.pyo
   /usr/lib/python2.6/site-packages/HMMEditor.py
   /usr/lib/python2.6/site-packages/HMMEditor.pyc
   /usr/lib/python2.6/site-packages/HMMEditor.pyo
   /usr/lib/python2.6/site-packages/ObjectHMM.py
   /usr/lib/python2.6/site-packages/ObjectHMM.pyc
   /usr/lib/python2.6/site-packages/ObjectHMM.pyo

on 64bit python_sitearch is /usr/lib64/python2.6/site-packages.

Don't know why koji could build and rpmbuild don't...

Why do you sed in %setup? for CFLAGS

You can export CFLAGS in the %configure line with 
CFLAGS="${RPM_OPT_FLAGS}" %configure --enable-gsl --enable-experimental --enable-unsupported


--enable-atlas and --disable-static would be good.
Comment 10 Thomas Spura 2009-10-18 20:35:29 EDT
And from https://bugzilla.redhat.com/show_bug.cgi?id=491545#c8 you should use your own review request and dublicate this… (whyever ;))
Comment 11 D Haley 2009-10-23 10:07:46 EDT
New report is at Bug 530568
Comment 12 Thomas Spura 2009-10-23 12:22:15 EDT

*** This bug has been marked as a duplicate of bug 530568 ***
Comment 13 Fedora Update System 2009-10-29 06:33:33 EDT
ghmm-0.7-4.svn2286.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/ghmm-0.7-4.svn2286.fc11
Comment 14 Fedora Update System 2009-10-29 06:33:39 EDT
ghmm-0.7-4.svn2286.el5 has been submitted as an update for Fedora EPEL 5.
http://admin.fedoraproject.org/updates/ghmm-0.7-4.svn2286.el5
Comment 15 Fedora Update System 2009-11-20 18:27:39 EST
ghmm-0.7-4.svn2286.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 16 Fedora Update System 2009-11-30 23:46:22 EST
ghmm-0.7-4.svn2286.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.